Add ios_test.sh.bazel_template

--
MOS_MIGRATED_REVID=92725547
diff --git a/src/main/java/com/google/devtools/build/lib/rules/objc/ExperimentalIosTestRule.java b/src/main/java/com/google/devtools/build/lib/rules/objc/ExperimentalIosTestRule.java
index 349b317..0960297 100644
--- a/src/main/java/com/google/devtools/build/lib/rules/objc/ExperimentalIosTestRule.java
+++ b/src/main/java/com/google/devtools/build/lib/rules/objc/ExperimentalIosTestRule.java
@@ -52,6 +52,7 @@
             .value(env.getLabel("//tools/objc/sim_devices:default")))
         .add(attr("$test_template", LABEL)
             .value(env.getLabel("//tools/objc:ios_test.sh.bazel_template")))
+        .add(attr("$test_runner", LABEL).value(env.getLabel("//tools/objc:testrunner")))
         .build();
   }
 
diff --git a/src/main/java/com/google/devtools/build/lib/rules/objc/IosDeviceProvider.java b/src/main/java/com/google/devtools/build/lib/rules/objc/IosDeviceProvider.java
index 98cf21d..5475ee9 100644
--- a/src/main/java/com/google/devtools/build/lib/rules/objc/IosDeviceProvider.java
+++ b/src/main/java/com/google/devtools/build/lib/rules/objc/IosDeviceProvider.java
@@ -80,7 +80,8 @@
   public IosTestSubstitutionProvider iosTestSubstitutionProvider() {
     return new IosTestSubstitutionProvider(ImmutableList.of(
         Substitution.of("%(device_type)s", getType()),
-        Substitution.of("%(simulator_sdk)s", getIosVersion())
+        Substitution.of("%(simulator_sdk)s", getIosVersion()),
+        Substitution.of("%(locale)s", getLocale())
     ));
   }
 }
diff --git a/src/main/java/com/google/devtools/build/lib/rules/objc/TestSupport.java b/src/main/java/com/google/devtools/build/lib/rules/objc/TestSupport.java
index b46ccf4..173c781 100644
--- a/src/main/java/com/google/devtools/build/lib/rules/objc/TestSupport.java
+++ b/src/main/java/com/google/devtools/build/lib/rules/objc/TestSupport.java
@@ -14,6 +14,7 @@
 
 package com.google.devtools.build.lib.rules.objc;
 
+import com.google.common.base.Optional;
 import com.google.common.base.Preconditions;
 import com.google.common.collect.ImmutableList;
 import com.google.common.collect.Iterables;
@@ -29,8 +30,6 @@
 import com.google.devtools.build.lib.collect.nestedset.NestedSetBuilder;
 import com.google.devtools.build.lib.util.FileType;
 
-import java.util.List;
-
 /**
  * Support for running XcTests.
  */
@@ -62,7 +61,7 @@
     // xctestIpa is the app bundle being tested
     Artifact xctestIpa = xctestIpa();
 
-    List<Substitution> substitutions = new ImmutableList.Builder<Substitution>()
+    ImmutableList.Builder<Substitution> substitutions = new ImmutableList.Builder<Substitution>()
         .add(Substitution.of("%(test_app_ipa)s", testIpa.getRootRelativePathString()))
         .add(Substitution.of("%(test_app_name)s", baseNameWithoutIpa(testIpa)))
 
@@ -71,14 +70,18 @@
 
         .add(Substitution.of("%(iossim_path)s", iossim().getRootRelativePath().getPathString()))
 
-        .addAll(deviceSubstitutions().getSubstitutionsForTestRunnerScript())
+        .addAll(deviceSubstitutions().getSubstitutionsForTestRunnerScript());
 
-        .build();
+    Optional<Artifact> testRunner = testRunner();
+    if (testRunner.isPresent()) {
+      substitutions.add(
+          Substitution.of("%(testrunner_binary)s", testRunner.get().getRootRelativePathString()));
+    }
 
     Artifact template = ruleContext.getPrerequisiteArtifact("$test_template", Mode.TARGET);
 
     ruleContext.registerAction(new TemplateExpansionAction(ruleContext.getActionOwner(),
-        template, generatedTestScript(), substitutions, /*executable=*/true));
+        template, generatedTestScript(), substitutions.build(), /*executable=*/true));
   }
 
   private IosTestSubstitutionProvider deviceSubstitutions() {
@@ -102,6 +105,13 @@
   }
 
   /**
+   * Gets the binary of the testrunner attribute, if there is one.
+   */
+  private Optional<Artifact> testRunner() {
+    return Optional.fromNullable(ruleContext.getPrerequisiteArtifact("$test_runner", Mode.TARGET));
+  }
+
+  /**
    * Adds all files needed to run this test to the passed Runfiles builder.
    */
   TestSupport addRunfiles(Runfiles.Builder runfilesBuilder) {
@@ -110,7 +120,8 @@
         .addArtifact(xctestIpa())
         .addArtifact(generatedTestScript())
         .addArtifact(iossim())
-        .addTransitiveArtifacts(deviceRunfiles());
+        .addTransitiveArtifacts(deviceRunfiles())
+        .addArtifacts(testRunner().asSet());
     return this;
   }
 
diff --git a/tools/objc/BUILD b/tools/objc/BUILD
index 4beb725..ebdc32d 100644
--- a/tools/objc/BUILD
+++ b/tools/objc/BUILD
@@ -43,3 +43,7 @@
     name = "srcs",
     srcs = glob(["**"]),
 )
+
+filegroup(
+    name = "testrunner",
+)
diff --git a/tools/objc/ios_test.sh.bazel_template b/tools/objc/ios_test.sh.bazel_template
new file mode 100644
index 0000000..3a95549
--- /dev/null
+++ b/tools/objc/ios_test.sh.bazel_template
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Copyright 2015 Google Inc. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -eu
+
+TEST_APP_DIR="$(mktemp -d -t test_app_dir)"
+unzip -qq -d "${TEST_APP_DIR}" "%(test_app_ipa)s"
+TEST_APP_DIR="${TEST_APP_DIR}/Payload/%(test_app_name)s.app"
+
+XCTEST_APP_DIR="$(mktemp -d -t xctest_app_dir)"
+unzip -qq -d "${XCTEST_APP_DIR}" "%(xctest_app_ipa)s"
+XCTEST_APP_DIR="${XCTEST_APP_DIR}/Payload/%(xctest_app_name)s.app"
+
+killall "iOS Simulator" >/dev/null 2>/dev/null || :
+
+SIMHOME="$(mktemp -d -t simhome)"
+
+LOGFILE="$(mktemp -t logfile)"
+
+"%(iossim_path)s" \
+    -u "${SIMHOME}" \
+    -d "%(device_type)s" \
+    -s "%(simulator_sdk)s" \
+    -t 60 \
+    -e DYLD_INSERT_LIBRARIES=/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneSimulator.platform/Developer/Library/PrivateFrameworks/IDEBundleInjection.framework/IDEBundleInjection \
+    -e "XCInjectBundle=${TEST_APP_DIR}" \
+    -e "XCInjectBundleInto=${XCTEST_APP_DIR}" \
+    -e DYLD_FALLBACK_FRAMEWORK_PATH=/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneSimulator.platform/Developer/Library/Frameworks \
+    "${XCTEST_APP_DIR}" \
+    -NSTreatUnknownArgumentsAsOpen NO \
+    -ApplePersistenceIgnoreState YES \
+    -XCTest All \
+    "${TEST_APP_DIR}" \
+    2>&1 | tee "${LOGFILE}"
+
+killall "iOS Simulator" >/dev/null 2>/dev/null || :
+
+# TODO(danielwh): Much better support for detecting failures. Actually parse the log.
+if grep -q "with [1-9].* failure" "${LOGFILE}"; then
+  exit 1
+fi